using CallCenterApi.DB;
using System;
using System.Collections.Generic;
using System.Data;
using System.Data.SqlClient;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace CallCenterApi.DAL
{
    /// <summary>
	/// 数据访问类:T_Wo_MaterialItems
	/// </summary>
	public partial class T_Wo_MaterialItems
    {
        public T_Wo_MaterialItems()
        { }
        #region  BasicMethod
        /// <summary>
        /// 是否存在该记录
        /// </summary>
        public bool Exists(int F_Id)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) from T_Wo_MaterialItems");
            strSql.Append(" where F_Id=@F_Id");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_Id", SqlDbType.Int,4)
            };
            parameters[0].Value = F_Id;

            return DbHelperSQL.Exists(strSql.ToString(), parameters);
        }


        /// <summary>
        /// 增加一条数据
        /// </summary>
        public int Add(CallCenterApi.Model.T_Wo_MaterialItems model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("insert into T_Wo_MaterialItems(");
            strSql.Append("F_MaterialCode,F_MaterialName,F_Formula,F_LoadingFee,F_UnLoadingFee,F_MaterialFee,F_ReturnQuantity,F_WoID,F_Remark,F_CreateBy,F_CreateOn)");
            strSql.Append(" values (");
            strSql.Append("@F_MaterialCode,@F_MaterialName,@F_Formula,@F_LoadingFee,@F_UnLoadingFee,@F_MaterialFee,@F_ReturnQuantity,@F_WoID,@F_Remark,@F_CreateBy,@F_CreateOn)");
            strSql.Append(";select @@IDENTITY");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_MaterialCode", SqlDbType.NVarChar,11),
                    new SqlParameter("@F_MaterialName", SqlDbType.NVarChar,2000),
                    new SqlParameter("@F_Formula", SqlDbType.NVarChar,200),
                    new SqlParameter("@F_LoadingFee", SqlDbType.Decimal,9),
                    new SqlParameter("@F_UnLoadingFee", SqlDbType.Decimal,9),
                    new SqlParameter("@F_MaterialFee", SqlDbType.Decimal,9),
                    new SqlParameter("@F_ReturnQuantity", SqlDbType.Int,4),
                    new SqlParameter("@F_WoID", SqlDbType.BigInt,8),
                    new SqlParameter("@F_Remark", SqlDbType.NText),
                    new SqlParameter("@F_CreateBy", SqlDbType.VarChar,50),
                    new SqlParameter("@F_CreateOn", SqlDbType.DateTime)};
            parameters[0].Value = model.F_MaterialCode;
            parameters[1].Value = model.F_MaterialName;
            parameters[2].Value = model.F_Formula;
            parameters[3].Value = model.F_LoadingFee;
            parameters[4].Value = model.F_UnLoadingFee;
            parameters[5].Value = model.F_MaterialFee;
            parameters[6].Value = model.F_ReturnQuantity;
            parameters[7].Value = model.F_WoID;
            parameters[8].Value = model.F_Remark;
            parameters[9].Value = model.F_CreateBy;
            parameters[10].Value = model.F_CreateOn;

            object obj = DbHelperSQL.GetSingle(strSql.ToString(), parameters);
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 更新一条数据
        /// </summary>
        public bool Update(CallCenterApi.Model.T_Wo_MaterialItems model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("update T_Wo_MaterialItems set ");
            strSql.Append("F_MaterialCode=@F_MaterialCode,");
            strSql.Append("F_MaterialName=@F_MaterialName,");
            strSql.Append("F_Formula=@F_Formula,");
            strSql.Append("F_LoadingFee=@F_LoadingFee,");
            strSql.Append("F_UnLoadingFee=@F_UnLoadingFee,");
            strSql.Append("F_MaterialFee=@F_MaterialFee,");
            strSql.Append("F_ReturnQuantity=@F_ReturnQuantity,");
            strSql.Append("F_WoID=@F_WoID,");
            strSql.Append("F_Remark=@F_Remark,");
            strSql.Append("F_CreateBy=@F_CreateBy,");
            strSql.Append("F_CreateOn=@F_CreateOn");
            strSql.Append(" where F_Id=@F_Id");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_MaterialCode", SqlDbType.NVarChar,11),
                    new SqlParameter("@F_MaterialName", SqlDbType.NVarChar,2000),
                    new SqlParameter("@F_Formula", SqlDbType.NVarChar,200),
                    new SqlParameter("@F_LoadingFee", SqlDbType.Decimal,9),
                    new SqlParameter("@F_UnLoadingFee", SqlDbType.Decimal,9),
                    new SqlParameter("@F_MaterialFee", SqlDbType.Decimal,9),
                    new SqlParameter("@F_ReturnQuantity", SqlDbType.Int,4),
                    new SqlParameter("@F_WoID", SqlDbType.BigInt,8),
                    new SqlParameter("@F_Remark", SqlDbType.NText),
                    new SqlParameter("@F_CreateBy", SqlDbType.VarChar,50),
                    new SqlParameter("@F_CreateOn", SqlDbType.DateTime),
                    new SqlParameter("@F_Id", SqlDbType.Int,4)};
            parameters[0].Value = model.F_MaterialCode;
            parameters[1].Value = model.F_MaterialName;
            parameters[2].Value = model.F_Formula;
            parameters[3].Value = model.F_LoadingFee;
            parameters[4].Value = model.F_UnLoadingFee;
            parameters[5].Value = model.F_MaterialFee;
            parameters[6].Value = model.F_ReturnQuantity;
            parameters[7].Value = model.F_WoID;
            parameters[8].Value = model.F_Remark;
            parameters[9].Value = model.F_CreateBy;
            parameters[10].Value = model.F_CreateOn;
            parameters[11].Value = model.F_Id;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        /// <summary>
        /// 删除一条数据
        /// </summary>
        public bool Delete(int F_Id)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Wo_MaterialItems ");
            strSql.Append(" where F_Id=@F_Id");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_Id", SqlDbType.Int,4)
            };
            parameters[0].Value = F_Id;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }
        /// <summary>
        /// 批量删除数据
        /// </summary>
        public bool DeleteList(string F_Idlist)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Wo_MaterialItems ");
            strSql.Append(" where F_Id in (" + F_Idlist + ")  ");
            int rows = DbHelperSQL.ExecuteSql(strSql.ToString());
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public CallCenterApi.Model.T_Wo_MaterialItems GetModel(int F_Id)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("select  top 1 F_Id,F_MaterialCode,F_MaterialName,F_Formula,F_LoadingFee,F_UnLoadingFee,F_MaterialFee,F_ReturnQuantity,F_WoID,F_Remark,F_CreateBy,F_CreateOn from T_Wo_MaterialItems ");
            strSql.Append(" where F_Id=@F_Id");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_Id", SqlDbType.Int,4)
            };
            parameters[0].Value = F_Id;

            CallCenterApi.Model.T_Wo_MaterialItems model = new CallCenterApi.Model.T_Wo_MaterialItems();
            DataSet ds = DbHelperSQL.Query(strSql.ToString(), parameters);
            if (ds.Tables[0].Rows.Count > 0)
            {
                return DataRowToModel(ds.Tables[0].Rows[0]);
            }
            else
            {
                return null;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public CallCenterApi.Model.T_Wo_MaterialItems DataRowToModel(DataRow row)
        {
            CallCenterApi.Model.T_Wo_MaterialItems model = new CallCenterApi.Model.T_Wo_MaterialItems();
            if (row != null)
            {
                if (row["F_Id"] != null && row["F_Id"].ToString() != "")
                {
                    model.F_Id = int.Parse(row["F_Id"].ToString());
                }
                if (row["F_MaterialCode"] != null)
                {
                    model.F_MaterialCode = row["F_MaterialCode"].ToString();
                }
                if (row["F_MaterialName"] != null)
                {
                    model.F_MaterialName = row["F_MaterialName"].ToString();
                }
                if (row["F_Formula"] != null)
                {
                    model.F_Formula = row["F_Formula"].ToString();
                }
                if (row["F_LoadingFee"] != null && row["F_LoadingFee"].ToString() != "")
                {
                    model.F_LoadingFee = decimal.Parse(row["F_LoadingFee"].ToString());
                }
                if (row["F_UnLoadingFee"] != null && row["F_UnLoadingFee"].ToString() != "")
                {
                    model.F_UnLoadingFee = decimal.Parse(row["F_UnLoadingFee"].ToString());
                }
                if (row["F_MaterialFee"] != null && row["F_MaterialFee"].ToString() != "")
                {
                    model.F_MaterialFee = decimal.Parse(row["F_MaterialFee"].ToString());
                }
                if (row["F_ReturnQuantity"] != null && row["F_ReturnQuantity"].ToString() != "")
                {
                    model.F_ReturnQuantity = int.Parse(row["F_ReturnQuantity"].ToString());
                }
                if (row["F_WoID"] != null && row["F_WoID"].ToString() != "")
                {
                    model.F_WoID = long.Parse(row["F_WoID"].ToString());
                }
                if (row["F_Remark"] != null)
                {
                    model.F_Remark = row["F_Remark"].ToString();
                }
                if (row["F_CreateBy"] != null)
                {
                    model.F_CreateBy = row["F_CreateBy"].ToString();
                }
                if (row["F_CreateOn"] != null && row["F_CreateOn"].ToString() != "")
                {
                    model.F_CreateOn = DateTime.Parse(row["F_CreateOn"].ToString());
                }
            }
            return model;
        }

        /// <summary>
        /// 获得数据列表
        /// </summary>
        public DataSet GetList(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select F_Id,F_MaterialCode,F_MaterialName,F_Formula,F_LoadingFee,F_UnLoadingFee,F_MaterialFee,F_ReturnQuantity,F_WoID,F_Remark,F_CreateBy,F_CreateOn ");
            strSql.Append(" FROM T_Wo_MaterialItems ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获得前几行数据
        /// </summary>
        public DataSet GetList(int Top, string strWhere, string filedOrder)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select ");
            if (Top > 0)
            {
                strSql.Append(" top " + Top.ToString());
            }
            strSql.Append(" F_Id,F_MaterialCode,F_MaterialName,F_Formula,F_LoadingFee,F_UnLoadingFee,F_MaterialFee,F_ReturnQuantity,F_WoID,F_Remark,F_CreateBy,F_CreateOn ");
            strSql.Append(" FROM T_Wo_MaterialItems ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            strSql.Append(" order by " + filedOrder);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获取记录总数
        /// </summary>
        public int GetRecordCount(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) FROM T_Wo_MaterialItems ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            object obj = DbHelperSQL.GetSingle(strSql.ToString());
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        public DataSet GetListByPage(string strWhere, string orderby, int startIndex, int endIndex)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("SELECT * FROM ( ");
            strSql.Append(" SELECT ROW_NUMBER() OVER (");
            if (!string.IsNullOrEmpty(orderby.Trim()))
            {
                strSql.Append("order by T." + orderby);
            }
            else
            {
                strSql.Append("order by T.F_Id desc");
            }
            strSql.Append(")AS Row, T.*  from T_Wo_MaterialItems T ");
            if (!string.IsNullOrEmpty(strWhere.Trim()))
            {
                strSql.Append(" WHERE " + strWhere);
            }
            strSql.Append(" ) TT");
            strSql.AppendFormat(" WHERE TT.Row between {0} and {1}", startIndex, endIndex);
            return DbHelperSQL.Query(strSql.ToString());
        }

        #endregion  BasicMethod
        #region  ExtensionMethod

        #endregion  ExtensionMethod
    }
}
